---
title: Initialize the framework
slug: Games/Tutorials/2D_breakout_game_Phaser/Initialize_the_framework
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - HTML
  - JavaScript
  - Phaser
  - Tutorial
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser", "Games/Workflows/2D_Breakout_game_Phaser/Scaling")}}</p>

<div class="summary">
<p>This is the first of 16 tutorials to learn how to use <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser</a>. After completing this tutorial you can find the source code for this section at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson01.html">Gamedev-Phaser-Content-Kit/demos/lesson01.html</a>.</p>
</div>

<p><span class="seoSummary">Before we can start writing the game's functionality, we need to create a basic structure to render the game inside. This can be done using HTML — the Phaser framework will generate the required {{htmlelement("canvas")}} element.</span></p>

<h2 id="The_games_HTML">The game's HTML</h2>

<p>The HTML document structure is quite simple, as the game will be rendered entirely on the {{htmlelement("canvas")}} element generated by the framework. Using your favourite text editor, create a new HTML document, save it as <code>index.html</code>, in a sensible location, and add the following code to it:</p>

<pre class="brush: html notranslate">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
    &lt;meta charset="utf-8" /&gt;
    &lt;title&gt;Gamedev Phaser Workshop - lesson 01: Initialize the framework&lt;/title&gt;
    &lt;style&gt;* { padding: 0; margin: 0; }&lt;/style&gt;
    &lt;script src="js/phaser.min.js"&gt;&lt;/script&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;script&gt;
    var game = new Phaser.Game(480, 320, Phaser.CANVAS, null, {
      preload: preload, create: create, update: update
    });
    function preload() {}
    function create() {}
    function update() {}
&lt;/script&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<h2 id="Downloading_the_Phaser_code">Downloading the Phaser code</h2>

<p>Next, we need to go through the process of downloading the Phaser source code and applying it to our HTML document. This tutorial uses Phaser V2 — it won't work with the current version on Phaser (V3). The V2 library is still available on the Phaser download page, below the links for the V3 download.</p>

<ol>
 <li>Go to the <a href="http://phaser.io/download/stable">Phaser download page</a>.</li>
 <li>Choose an option that suits you best — I would recommend the <em>min.js</em> option as it keeps the source code smaller, and you are unlikely need to go through the source code anyway.</li>
 <li>Save the Phaser code inside a <code>/js</code> directory in the same location as your <code>index.html</code> file.</li>
 <li>Update the <code>src</code> value of the first {{htmlelement("script")}} element as shown above.</li>
</ol>

<h2 id="Walking_through_what_we_have_so_far">Walking through what we have so far</h2>

<p>At this point we have a <code>charset</code> defined, {{htmlelement("title")}} and some basic CSS in the header to reset the default <code>margin</code> and <code>padding</code>. We also have a {{htmlelement("script")}} element to apply the Phaser source code to the page. The body contains a second {{htmlelement("script")}} element, where we will write the JavaScript code to render the game and control it.</p>

<p>The {{htmlelement("canvas")}} element is generated automatically by the framework. We are initializing it by creating a new <code>Phaser.Game</code> object and assigning it to the game variable. The parameters are:</p>

<ul>
 <li>The width and height to set the {{htmlelement("canvas")}} to.</li>
 <li>The rendering method. The three options are <code>AUTO</code>, <code>CANVAS</code> and <code>WEBGL</code>. We can set one of the latter two explicitly or use <code>AUTO</code> to let Phaser decide which one to use. It usually uses WebGL if available in the browser, falling back to Canvas 2D if not.</li>
 <li>The <code>id</code> of the {{htmlelement("canvas")}} to use for rendering if one already exists on the page (we've specified null because we want Phaser to create its own.)</li>
 <li>The names to use for Phaser's three key functions that load and start the game, and update the game loop on every frame; we will use the same names to keep it clean.
  <ul>
   <li><code>preload</code> takes care of preloading the assets</li>
   <li><code>create</code> is executed once when everything is loaded and ready</li>
   <li><code>update</code> is executed on every frame.</li>
  </ul>
 </li>
</ul>

<h2 id="Compare_your_code">Compare your code</h2>

<p>Here's the full source code of the first lesson, running live in a JSFiddle:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/h6cwzv2b/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>Now we've set up the basic HTML and learned a bit about Phaser initialization, let's continue to the second lesson and learn about <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Scaling">scaling</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser", "Games/Workflows/2D_Breakout_game_Phaser/Scaling")}}</p>
